<h1 align="center">aescripts Paint &amp; Stick: C4D Exporter</h1>

![Summary Screenshot](http://i.imgur.com/msToC3h.png)

__COMPILATION INSTRUCTIONS__

    # Install Craftr build system
    pip --user install craftr-build
    
    # Clone the repository into the C4D plugins folder
    cd ~/Applications/Cinema 4D R15/plugins
    git clone git@github.com:aescripts/C4D-Sticky-Pass-Exporter --recursive
    cd C4D-Sticky-Pass-Exporter
    
    # Build the plugin
    craftr               # release build
    craftr -Ddebug       # debug build
    craftr .archive      # create archive (keep -Ddebug for debug build)

__CHANGELOG__

__v1.2-rc3__

* [#81][] Bounding-Box Scaling parameter defaults to 200%

__v1.2-rc2__

* [#81][] add Bounding-Box Scaling parameter to P&S Video Post

__v1.2-rc1__

* Rename PNS Tag Sticky Pass "Off" mode to "Auto"
* [#81][] object bounding box is now scaled by 5%
* [#80][] fix "Render C4D" checkbox
* [#79][] array of spheres are yellow on ID pass
* [#78][] auto setup: disable object visibility when object is not Seen
  by Camera (as determined from compositing tags)

[#81]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/81
[#80]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/80
[#79]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/79
[#78]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/78

__1.1-rc9__

* "Delete P&S Tags" now resets the "Allocated IDs" info parameter
* Add "About" tab

__v1.1-rc8__

* [#73][] Remove "Render Perfect" error check
* [#75][] Cloth appears black on Sticky Pass
* [#76][] Don't take "Render Scene" checkbox in Editor Render into account
* Fix VideoPost GUI not opening in R14 (due to unsupported resource flag)
* Print time needed after sticking scene

[#73]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/73
[#75]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/75
[#76]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/76

__v1.1-rc7__

* [#68][] Twist-Deformed Fillet Cap text cannot be stuck
* [#70][] Auto Setup doesn't disable automatic render-state evaluation when tag is added
* [#71][] Set floor objects to always be black on both passes

[#68]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/68
[#70]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/70
[#71]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/71

__v1.1-rc6__

* [#58][] Add new button: Select Paint & Stick tags of selected objects
* [#56][], [#57][], [#59][], [#60][], [#61][] Text changes
* [#54][] Remove special characters from multipass layer names, ensure
  the user can not create buffers with special characters (fixes multipass
  save bug in R17+)
* [#62][] Render Instances are not tagged until fixed
* [#66][] Add "Subdivisions" parameter to Error Check dialog Render Perfect tab
* [#67][] Fixed yellow objects for Instance Objects referecing Sweeps

[#54]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/54
[#56]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/56
[#57]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/57
[#58]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/58
[#59]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/59
[#60]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/60
[#61]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/61
[#62]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/62
[#66]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/66
[#67]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/67

__v1.1-rc5__

* [#48][] Renamed Paint & Stick Only Render Settings, create them as
  child Render Settings, unhide 'Render Scene' checkbox in VP settings
* [#49][] Fix 'Exclude semi-transparent Objects' always on or always off
* [#50][] Fix behaviour of 'Step #2' button
* [#51][] Stick vertex colors on deformed version of objects rather than
  their original un-deformed version
* [#52][] Set Render Engine to C4D Standard for Paint & Stick Only settings
* Error Check Dialog update (strings, layout, colors)

[#48]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/48
[#49]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/49
[#50]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/50
[#51]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/51
[#52]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/52

__v1.1-rc4__

* [#21][] Support for automatic detection of animated vertices
* Merged Lazaros' error checking code
* Video Post UI update
* [#41][] Implement Render Buffers

[#41]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/41

__v1.1-rc3__

* Fixed "Freeze" command not sticking some objects in nested hierarchies
* Fixed distribution of color IDs in Multi Cache objects with complicated
  nested hierarchies
* Fix missing update of the editor when using the "Freeze" command
* Fix primitves getting a P&S Tag under an SDS object
* [#31][] Instances & Render Instances
* Added buttons and info text to Video Post, ability to Hide and Show
  P&S tags, delete all of them and useful buttons to set up the correct
  render settings (by Lazaros)

[#31]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/31

__v1.1-rc2__

* Add "Allocated IDs" string field in Video Post
* "Render Scene" parameter in Video Post is now on by default
* Automatically enable multipasses when Video Post is added
* [#13][] P&S Tag now automatically enables Vertex Color freezing
  on Polygon Objects with Cloth Tags
* [#14][] Objects without P&S Tag or with Color Mode set to "Matte" now
  render black in the Sticky Pass, too
* [#16][] Fix crash with Instance Objects
* [#18][] Hold the ESC key to cancel the Color ID Freeze operation
* [#21][] Support for automated Vertex Color freezing
  deforming tags/tracks/objects
* Fixed a bug where empty PolygonObjects would be assigned one of
  the color IDs during rendering but not when the color ID range
  was assigned when freezing the scene
* [#22][] Fixed a bug where multi cache objects (eg. Figure) would
  render only partially
* [#24][] Freeze mapping now checks if real child objects are being
  deformed for objects that require inputs like the Subdivision Surface
  and other modeling objects
* [#24][] Fix bounding box computation in "Full Object" mode  for objects
  like the SDS that dont support a usable bounding box by hard-computing
  it from the polygonal cache
* [#24][] Fix freezing of vertex colors in render state rather then
  editor state (eg. important for SDS vertex colors)
* P&S Tag in "Individual Objects" mode now draws the bounding box for
  each geometrical object in the virtual object instead of only once
  for the Tag host object (which visualizes the box incorrectly)
* Fixed a bug in collecting the already used IDs that included the
  zero as a valid color ID (happened when manually creating P&S Tags
  and then executing the freeze)
* Fixed a problem that caused the viewport drawing of the tag to be
  highlit when the object of the tag was also selected
* [#27][] Fixed a problem where nested modeling objects would all
  receive a P&S Tag while only the topmost object should receive it
* [#28][] P&S Tag "Update" button now executes the current frame in
  render mode to stick vertex colors to the render state of the scene
* Add "Paint & Stick: Freeze!" command in the Plugins menu which 
  creates a P&S Video Post and runs the Freeze! button
* Pressing the "Update" button on a Tag while in a mode that does not
  save vertex colors (Off, UVW), the vertex color mapping is deleted
* [#20][] Possible crash with real scene modifications

[#13]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/13
[#14]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/14
[#16]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/16
[#18]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/18
[#21]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/21
[#22]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/22
[#24]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/22
[#27]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/27
[#28]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/28
[#20]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/20

__v1.1-rc1__

* Reduced plugin complexity by removing Update, Exclude, Color Tags and
  the Paint & Stick command, only the Paint & Stick Tag and Video Post
  remain
* Added "Freeze Color IDs..." button to Video Post that kind-of does what
  the previous Paint & Stick Command did
* [#11][] Paint & Stick Tag now contains *all* color ID information for an object,
  including color ranges for multi-cache objects
* [#10][] Paint & Stick Tag "Auto Fit" mode now determines a proper bounding box
  in "Individual Objects" mode
* [#9][] Paint & Stick Tag now automatically determines a matchign "Vertex Color"
  mode for the object (based on whether it is deformed and if it is a 
  multi-cache object or not)
* Implemented an efficient color allocation and re-use algorithm and
  datastructure (see the class `ColorRangeData` in `mapping.h`)
* Made Video Post parameter not animateable

[#9]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/9
[#10]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/10
[#11]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/11

__v1.0-headstart__

* Naively merged the two code bases into one. For further information see
  Issue [#1][] and the merge commit [78ec38a][].

[#1]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/issues/1
[78ec38a]: https://github.com/aescripts/C4D-Sticky-Pass-Exporter/commit/78ec38af7b6708750bae56855ef20b494a58401c
